diff --git a/src/django_scrypt_fmt_plug.c b/src/django_scrypt_fmt_plug.c
index ceffac8cbc..a79538163f 100644
--- a/src/django_scrypt_fmt_plug.c
+++ b/src/django_scrypt_fmt_plug.c
@@ -35,11 +35,11 @@ john_register_one(&fmt_django_scrypt);
 #define FORMAT_NAME		""
 #define FORMAT_TAG		"scrypt$"
 #define TAG_LENGTH		(sizeof(FORMAT_TAG)-1)
-#ifdef __XOP__
+#if !defined(JOHN_NO_SIMD) && defined(__XOP__)
 #define ALGORITHM_NAME		"Salsa20/8 128/128 XOP"
-#elif defined(__AVX__)
+#elif !defined(JOHN_NO_SIMD) && defined(__AVX__)
 #define ALGORITHM_NAME		"Salsa20/8 128/128 AVX"
-#elif defined(__SSE2__)
+#elif !defined(JOHN_NO_SIMD) && defined(__SSE2__)
 #define ALGORITHM_NAME		"Salsa20/8 128/128 SSE2"
 #else
 #define ALGORITHM_NAME		"Salsa20/8 32/" ARCH_BITS_STR
diff --git a/src/escrypt/Makefile.in b/src/escrypt/Makefile.in
index 999108c511..d6d3d6419a 100644
--- a/src/escrypt/Makefile.in
+++ b/src/escrypt/Makefile.in
@@ -20,7 +20,7 @@
 CC = @CC@
 LD = @LD@
 RM = /bin/rm -f
-CFLAGS = @CFLAGS@
+CFLAGS = @CFLAGS@ @JOHN_NO_SIMD@
 #CFLAGS = -Wall -O2 -fomit-frame-pointer
 LDFLAGS = @LDFLAGS@
 
diff --git a/src/escrypt/crypto_scrypt-best.c b/src/escrypt/crypto_scrypt-best.c
index 143e5cda96..ef62175e4f 100644
--- a/src/escrypt/crypto_scrypt-best.c
+++ b/src/escrypt/crypto_scrypt-best.c
@@ -1,4 +1,4 @@
-#if defined (__SSE2__) || defined (_MSC_VER)
+#if !defined(JOHN_NO_SIMD) && (defined (__SSE2__) || defined (_MSC_VER))
 #include "crypto_scrypt-sse.c"
 #else
 #include "crypto_scrypt-nosse.c"
diff --git a/src/scrypt_fmt.c b/src/scrypt_fmt.c
index 208912cb10..29dfaf6b4b 100644
--- a/src/scrypt_fmt.c
+++ b/src/scrypt_fmt.c
@@ -32,11 +32,11 @@
 #define FMT_CISCO9_LEN          (sizeof(FMT_CISCO9)-1)
 #define FMT_SCRYPTKDF			"$ScryptKDF.pm$"
 #define FMT_SCRYPTKDF_LEN       (sizeof(FMT_SCRYPTKDF)-1)
-#ifdef __XOP__
+#if !defined(JOHN_NO_SIMD) && defined(__XOP__)
 #define ALGORITHM_NAME			"Salsa20/8 128/128 XOP"
-#elif defined(__AVX__)
+#elif !defined(JOHN_NO_SIMD) && defined(__AVX__)
 #define ALGORITHM_NAME			"Salsa20/8 128/128 AVX"
-#elif defined(__SSE2__)
+#elif !defined(JOHN_NO_SIMD) && defined(__SSE2__)
 #define ALGORITHM_NAME			"Salsa20/8 128/128 SSE2"
 #else
 #define ALGORITHM_NAME			"Salsa20/8 32/" ARCH_BITS_STR
